package cn.com.ty.lift.common.constants;

/**
 * @author huangy
 * @date 2019-11-29
 * @description api常量
 */
public class ApiConstants {
    /**
     * 处理结果 1:成功
     */
    public static final String RESULT_SUCCESS = "1";
    /**
     * 处理结果 0:失败
     */
    public static final String RESULT_ERROR = "0";

    /**
     * 没有数据 9:更新0件、没数据
     */
    public static final String RESULT_NO_DATA = "9";

    /**
     * 程序异常
     */
    public static final String RESULT_EXCEPTION = "-1";

    /**
     * 当前用户
     */
    public static final String CURRENT_USER = "currentUser";

    /**
     * 已删除
     */
    public static final int DELETE_YES = 1;

    /**
     * 未删除
     */
    public static final int DELETE_NO = 0;


    /**
     * 菜单根节点父id
     */
    public static final Long ROOT_MENU_PARENT_ID = 0L;

    /**
     * 区域根节点父id
     */
    public static final String ROOT_AREA_PARENT_ID = "0";

    /**
     * 菜单父节点属性名
     */
    public static final String MENU_PARENT_ATTR = "parentId";

    /**
     * 区域
     */
    public static final String AREA_PARENT_ATTR = "parent";

    /**
     * 用户常量
     */
    public interface UserConstants {
        /**
         * 超级管理员/平台管理员
         */
        int TYPE_SUPER_ADMIN = 0;

        /**
         * 企业管理员
         */
        int TYPE_ENTERPRISE_ADMIN = 1;

        /**
         * 普通用户
         */
        int TYPE_USER = 2;
    }

    /**
     * 企业常量
     */
    public interface CompanyConstants {
        /**
         * 未认证
         */
        int MAINTENANCE_NOT_CERTIFICATE = 0;

        /**
         * 已认证
         */
        int MAINTENANCE_PASS = 1;

        /**
         * 审核中
         */
        int MAINTENANCE_WAIT_CERTIFICATE = 2;

        /**
         * 认证失败
         */
        int MAINTENANCE_FAIL = 3;

    }

    /**
     * 申请常量
     */
    public interface ApplicationConstants {
        /**
         * 申请加入团队
         */
        int APPLY_TYPE_TEAM = 1;
        /**
         * 申请加入项目
         */
        int APPLY_TYPE_PROJECT = 2;
        /**
         * 用户认证通过
         */
        int COMPANY_USER_PASS = 1;

        /**
         * 用户待审核
         */
        int COMPANY_USER_WAIT = 2;

        /**
         * 用户审核不通过
         */
        int COMPANY_USER_FAIL = -1;
    }

}
