package cn.com.ty.lift.enterprise.custom.service.impl;

import cn.com.ty.lift.enterprise.custom.dao.entity.PropertyContact;
import cn.com.ty.lift.enterprise.custom.dao.mapper.PropertyContactMapper;
import cn.com.ty.lift.enterprise.custom.service.PropertyContactService;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.AllArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;

/**
 * <p>
 * (甲方联系人)客户联系人表 服务实现类
 * </p>
 *
 * @author wang-hai-cheng
 * @since 2019-11-11
 */
@Service
@Transactional
@AllArgsConstructor
public class PropertyContactServiceImpl extends ServiceImpl<PropertyContactMapper, PropertyContact> implements PropertyContactService {
    private final RestTemplate restTemplate;

    public RestResponse delete(Long id) {
        PropertyContact byId = this.getById(id);
        if (null == byId) {
            return RestResponse.ok(null, "9", "无数据");
        }
        //获取联系人在项目表中是否有还在维保中的项目信息
        HashMap<String, Object> map = new HashMap<>();
        map.put("projectStatus", 2);
        map.put("ppContactId", id);
        map.put("ppCompanyId", byId.getPpCompanyId());
        map.put("pageNum", 1);
        map.put("pageSize", 1);
        ResponseEntity<HashMap> objectResponseEntity = restTemplate.postForEntity("http://132.232.206.88:20227/project/companyProjectList", map, HashMap.class);
        String statusCode = (String) objectResponseEntity.getBody().get("statusCode");
        //还有维保的项目就不能删除联系人
        if (statusCode.equals("1")) {
            //就不删除
            return RestResponse.ok(null, "0", "有正在服务的关联项目，无法删除");
        }
        byId.setStatus(0);
        if (this.update(byId, new QueryWrapper<PropertyContact>().eq("id", byId.getId()))) {
            return RestResponse.ok(null, "1", "删除成功");
        } else {
            return RestResponse.ok(null, "0", "删除失败");
        }
    }
}