package cn.com.ty.lift.system.user.service.impl;

import cn.com.ty.lift.common.constants.ApiConstants;
import cn.com.ty.lift.system.user.dao.entity.UserApplication;
import cn.com.ty.lift.system.user.dao.entity.model.UserApplyRequest;
import cn.com.ty.lift.system.user.dao.mapper.UserApplicationMapper;
import cn.com.ty.lift.system.user.service.IUserApplicationService;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

/**
 * <p>
 * 用户申请表 服务实现类
 * </p>
 *
 * @author wang-hai-cheng
 * @since 2019-12-13
 */
@Service
public class UserApplicationService extends ServiceImpl<UserApplicationMapper, UserApplication> implements IUserApplicationService {

    @Override
    public RestResponse applyTeam(UserApplyRequest userApplyRequest) {
        //判断用户是否申请过
        UserApplication userApplication = new UserApplication();
        userApplication.setMtCompanyId(userApplyRequest.getCompanyId());
        userApplication.setUserId(userApplyRequest.getUserId());
        //设置申请类型为团队
        userApplication.setType(ApiConstants.ApplicationConstants.APPLY_TYPE_TEAM);
        //审核状态变为待审核
        userApplication.setStatus(ApiConstants.ApplicationConstants.COMPANY_USER_WAIT);
        return RestResponse.ok(null, ApiConstants.RESULT_SUCCESS, "申请成功");
    }

    @Override
    public RestResponse teamPass(UserApplyRequest userApplyRequest) {
        return RestResponse.ok(null, ApiConstants.RESULT_SUCCESS, "操作成功");
    }

    @Override
    public RestResponse teamFail(UserApplyRequest userApplyRequest) {
        UserApplication userApplication = this.getById(userApplyRequest.getId());
        userApplication.setStatus(ApiConstants.ApplicationConstants.COMPANY_USER_FAIL);
        this.updateById(userApplication);
        return RestResponse.ok(null, ApiConstants.RESULT_SUCCESS, "操作成功");
    }
}
